404

[ Avaa Bypassed ]




Upload:

Command:

botdev@3.22.101.47: ~ $
#!/bin/bash
#                               -*- Mode: Sh -*-
# updateConfFile.sh ---
# Author           : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com )
# Created On       : Fri Feb  1 03:41:47 2002
# Created On Node  : glaurung.green-gryphon.com
# Last Modified By : Manoj Srivastava
# Last Modified On : Tue Jun  6 09:48:22 2006
# Last Machine Used: glaurung.internal.golden-gryphon.com
# Update Count     : 186
# Status           : Unknown, Use with caution!
# HISTORY          :
# Description      :
#
# This script attempts to provide conffile like handling for files not
# shipped in a Debian package, but handled by the postinst. Using this
# script, one may ship a bunch of default cofiguration files somewhere
# in /usr (/usr/share/<pkg> is a good location), and maintain files in
# /etc.
#
# The motivation for this script was to provide conffile like handling
# for start files for emacs lisp packages (for example,
# /etc/emacs21/site-stard.d/50psgml-init.el) These start files are not
# shipped with the package, instead, they are installed during the
# post installation configuration phase by the script
# /usr/lib/emacsen-common/emacs-package-install $package_name.
#
# This script is meant to be invoked by the packages install script at
# /usr/lib/emacsen-common/packages/install/$package_name for each
# flavour of installed emacsen by calling it with the proper values of
# new file (/usr/share/emacs/site-lisp/<pkg>/<pkg>-init.el), and dest file
# (/etc/emacs21/site-stard.d/50<pkg>-init.el)), and it should do the rest.
#

# make sure we exit on error
set -e

# set the version and revision
progname="$(basename $0)"
pversion='Revision: 3.00 '

unset GREP_OPTIONS

######################################################################
########                                                     #########
########              Utility functions                      #########
########                                                     #########
######################################################################
setq() {
    # Variable Value Doc_string
    if [ "x$2" = "x" ]; then
	echo >&2 "$progname: Unable to determine $3"
	exit 1;
    else
	if [ "x$VERBOSE" != "x" ]; then
	    echo >&2 "$progname: $3 is $2";
	fi
	eval "$1=\"\$2\"";
    fi
}

# Usage: get_file_metadate file_name
get_file_metadata()
{
    if [ -e "$1" ]; then
        # get file modification date without the nanoseconds and timezone info
        local moddate="$(date +"%F %T" --date $(stat --format '@%Y' "$1"))"
        # print file_name user.group permissions above_date
        stat --format "%n %U.%G 0%a $moddate" "$1"
    else
        echo "/dev/null"
    fi
}

# Runs the diff command with approrpiate arguments
# Usage run_diff diff|sdiff diff_opts old_file new_file
run_diff()
{
    local diff_cmd="$1"
    local diff_opt="$2"
    local old_file="$3"
    local new_file="$4"

    # Note: get_file_metadata not in quotes to ignore "\n" characters
    local old_file_label=$(get_file_metadata "$old_file")
    local new_file_label=$(get_file_metadata "$new_file")

    [ -e "$old_file" ] || old_file=/dev/null
    [ -e "$new_file" ] || new_file=/dev/null

    if [ "$diff_cmd" = "diff" ] ; then
      diff "$diff_opt" --label "$old_file_label" "$old_file" \
            --label "$new_file_label" "$new_file" || true
    elif [ "$diff_cmd" = "sdiff" ] ; then
      # unfortunatelly the sdiff command does not support --label option
      local out="$(sdiff "$diff_opt" "$old_file" "$new_file")" || true
      [ -z "$out" ] || printf "Old file: %s\nNew file: %s\n\n%s" \
                               "$old_file_label" "$new_file_label" "$out"
    else
      echo "Unknown diff command: $diff_cmd" >&2
      exit 1
    fi
}


# Use debconf to show the differences
# Usage: show_diff actual_file_differences file_stat_differences
show_diff() {
    if [ -z "$1" ]; then
	DIFF="There are no non-white space differences in the files."
    else
        if  [ 99999 -lt "$(echo $1 | wc -c | awk '{print $1; }')" ]; then
            DIFF="The differences between the files are too large to display."
        else
            DIFF="$1"
        fi
    fi
    if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then
	templ=ucf/show_diff
	db_capb escape
	db_subst $templ DIFF "$(printf %s "$DIFF" | debconf-escape -e)"
	db_fset $templ seen false
	db_input critical $templ || true
	db_go || true
	db_get $templ
	# may contain sensitive information, so clear
	# immediatly after use so it is never written
	# to disk
	db_subst $templ DIFF ""
	db_reset $templ
	db_capb
    else
        if [ -z "$my_pager" ]; then
	    echo "$DIFF" | sensible-pager
        else
	    echo "$DIFF" | $my_pager
        fi
    fi
}

withecho () {
        echo "$@" >&2
        "$@"
}

usageversion () {
        cat >&2 <<END
Debian GNU/Linux $progname $pversion.
           Copyright (C) 2002-2005 Manoj Srivastava.
This is free software; see the GNU General Public Licence for copying
conditions.  There is NO warranty.

Usage: $progname  [options] new_file  destination
Options:
     -h,     --help          print this message
     -s foo, --src-dir  foo  Set the src dir (historical md5sums live here)
             --sum-file bar  Force the historical md5sums to be read from
                             this file.  Overrides any setting of --src-dir.
     -d[n], --debug=[n]      Set the Debug level to N. Please note there must
                             be no spaces before the debug level
     -n,     --no-action     Dry run. No action is actually taken.
     -v,     --verbose       Make the script verbose
             --three-way     Register this file in the cache, and turn on the
                             diff3 option allowing the merging of maintainer
                             changes into a (potentially modified) local
                             configuration file. )
             --state-dir bar Set the state directory to bar instead of the
                             default '/var/lib/ucf'. Used mostly for testing.
             --debconf-ok    Indicate that it is ok for ucf to use an already
                             running debconf instance for prompting.
             --debconf-template bar
                             Specify an alternate, caller-provided debconf
                             template to use for prompting.
Usage: $progname  -p  destination
     -p,     --purge         Remove any reference to destination from records

By default, the directory the new_file lives in is assumed to be the src-dir,
which is where we look for any historical md5sums.

END

}

######################################################################
########                                                     #########
########        file and hash save/restore functions         #########
########                                                     #########
######################################################################
purge_md5sum () {
    for i in $(/usr/bin/seq 6 -1 0); do
	if [ -e "${statedir}/hashfile.${i}" ]; then
	    if [ "X$docmd" = "XYES" ]; then
		cp -pf "${statedir}/hashfile.${i}" \
		    "${statedir}/hashfile.$(($i+1))"
	    else
		echo cp -pf "${statedir}/hashfile.${i}" \
                          "${statedir}/hashfile.$(($i+1))"
	    fi
	fi
    done
    if [ -e "$statedir/hashfile" ]; then
	if [ "X$docmd" = "XYES" ]; then
	    cp -pf "$statedir/hashfile"  "$statedir/hashfile.0"
	else
	    echo cp -pf "$statedir/hashfile"  "$statedir/hashfile.0"
	fi
	if [ "X$docmd" = "XYES" ]; then
	    set +e
	    if [ "X$VERBOSE" != "X" ]; then
		echo >&2 "egrep -v [[:space:]]${safe_dest_file}$ $statedir/hashfile"
		egrep -v "[[:space:]]${safe_dest_file}$"  "$statedir/hashfile" >&2 \
		    || true;
	    fi
	    #echo "egrep -v [[:space:]]${safe_dest_file}$ $statedir/hashfile"
	    egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \
		"$statedir/hashfile.tmp" || true;
	    if [ "X$docmd" = "XYES" ]; then
		mv -f "$statedir/hashfile.tmp"  "$statedir/hashfile"
	    else
		echo mv -f "$statedir/hashfile.tmp"  "$statedir/hashfile"
	    fi
	    set -e
	fi
    fi
    test -n "$VERBOSE" && echo >&2 "The cache file is $cached_file"
    if [ ! -z "$cached_file" -a -f "$statedir/cache/$cached_file" ]; then
	$action rm -f "$statedir/cache/$cached_file"
    fi
}

replace_md5sum () {
    for i in $(/usr/bin/seq 6 -1 0); do
	if [ -e "${statedir}/hashfile.${i}" ]; then
	    if [ "X$docmd" = "XYES" ]; then
		cp -pf "${statedir}/hashfile.${i}" \
		    "${statedir}/hashfile.$(($i+1))"
	    else
		echo cp -pf "${statedir}/hashfile.${i}" \
		    "${statedir}/hashfile.$(($i+1))"
	    fi
	fi
    done
    if [ -e "$statedir/hashfile" ]; then
	if [ "X$docmd" = "XYES" ]; then
	    cp -pf "$statedir/hashfile"  "$statedir/hashfile.0"
	else
	    echo cp -pf "$statedir/hashfile"  "$statedir/hashfile.0"
	fi
	if [ "X$docmd" = "XYES" ]; then
	    set +e
	    if [ "X$VERBOSE" != "X" ]; then
		echo >&2 "(egrep -v \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\";"
		egrep -v "[[:space:]]${safe_dest_file}$"  "$statedir/hashfile" >&2 || true;
		md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >&2;
	    fi
	    egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \
		"$statedir/hashfile.tmp" || true;
	    md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >> \
		"$statedir/hashfile.tmp";
	    mv -f "$statedir/hashfile.tmp"  "$statedir/hashfile"
	    set -e
	else
	    echo "(egrep -v \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\""
	    echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\"; "
	    echo ") | sort > \"$statedir/hashfile\""
	fi
    else
	if [ "X$docmd" = "XYES" ]; then
	    md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|"  > \
		"$statedir/hashfile"
	else
	    echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\" >" \
		"\"$statedir/hashfile\""
	fi
    fi
    file_size=$(stat -c '%s' "$orig_new_file")
    if [ "X$THREEWAY" != "X" ] || [ "$file_size" -lt 25600 ]; then
	$action cp -pf "$orig_new_file" "$statedir/cache/$cached_file"
    fi
    # cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}"
}

replace_conf_file () {
    # do not mangle $dest_file since it's the one registered in the hashfile
    # or we have been ask to register
    real_file="$dest_file"
    if [ -L "$dest_file" ]; then
	real_file="$(readlink -nf $dest_file || :)"
	if [ "x$real_file" = "x" ]; then
	    echo >&2 "$dest_file is a broken symlink!"
	    $action rm -f "$dest_file";
	    real_file="$dest_file"
	fi
    fi
    if [ -e "$real_file" ]; then
	if [ -z "$RETAIN_OLD" ]; then
	    #echo "Saving  ${real_file}.${OLD_SUFFIX},  in case."
	    if [ "x$VERBOSE" != "x" ]; then
		echo >&2 "Not saving ${real_file}, since it was unmodified"
	    fi
	else
	    $action cp -pf "${real_file}" "${real_file}.${OLD_SUFFIX}"
	fi
    fi
    $action cp -pf "$new_file" "${real_file}"
    replace_md5sum;
}

# Escape single quotes in the arguments passed in
quote_single() {
    echo "$1" | sed -e "s,','\\\\'',g"
}



######################################################################
########                                                     #########
########              Command line args                      #########
########                                                     #########
######################################################################
#
# Long term variables#
#
docmd='YES'
action='withecho'
action=
DEBUG=0
VERBOSE=''
statedir='/var/lib/ucf';
THREEWAY=

DIST_SUFFIX="ucf-dist"
NEW_SUFFIX="ucf-new"
OLD_SUFFIX="ucf-old"
ERR_SUFFIX="merge-error"
# save up the cmdline with proper quoting/escaping
for arg in "$@"; do
    saved="${saved:+$saved }'$(quote_single "$arg")'"
done

# Note that we use `"$@"' to let each command-line parameter expand to a
# separate word. The quotes around `$@' are essential!
# We need TEMP as the `eval set --' would nuke the return value of getopt.
TEMP=$(getopt -a -o hs:d::D::nv -n "$progname" \
      --long help,src-dir:,sum-file:,dest-dir:,debug::,DEBUG::,no-action,purge,verbose,three-way,debconf-ok,debconf-template:,state-dir: \
             -- "$@")

# Note the quotes around `$TEMP': they are essential!
eval set -- "$TEMP"

while true ; do
    case "$1" in
	-h|--help) usageversion;                        exit 0 ;;
	-n|--no-action) action='echo'; docmd='NO';      shift  ;;
	-v|--verbose) VERBOSE=1;                        shift  ;;
	-s|--src-dir)
	    opt_source_dir="$2";                       shift 2 ;;
	--sum-file)
	    opt_old_mdsum_file="$2";		  shift 2 ;;
	--state-dir)
	    opt_state_dir="$2";                        shift 2 ;;
	--debconf-template)
	    override_template="$2";                    shift 2 ;;
	-D|-d|--debug|--DEBUG)
            # d has an optional argument. As we are in quoted mode,
            # an empty parameter will be generated if its optional
            # argument is not found.
	    case "$2" in
		"") setq DEBUG 1    "The Debug value"; shift 2 ;;
		*)  setq DEBUG "$2" "The Debug value"; shift 2 ;;
	    esac ;;
        -p|--purge) PURGE=YES;                         shift   ;;
       --three-way) THREEWAY=YES;                       shift   ;;
       --debconf-ok) DEBCONF_OK=YES;                    shift   ;;
	--)  shift ;                                   break   ;;
	*) echo >&2 "Internal error!" ; exit 1 ;;
    esac
done


######################################################################
########                                                     #########
########              Sanity checking                        #########
########                                                     #########
######################################################################
# Need to run as root, or else the
if test "$(id -u)" != 0; then
    if [ "$docmd" = "YES" ]; then
        echo "$progname: Need to be run as root." >&2
        echo "$progname: Setting up no action mode." >&2
        action='echo'; docmd='NO';
    fi
fi

if [ "X$PURGE" = "XYES" ]; then
    if [ $# != 1 ]; then
	echo >&2 "*** ERROR: Need exactly one argument when purging, got $#";
	echo >&2 ""
	usageversion;
	exit 2 ;
    fi
    temp_dest_file="$1";
    if [ -e "$temp_dest_file" ]; then
        setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file";
    else
        setq dest_file "$temp_dest_file" "The Destination file";
    fi
else
    if [ $# != 2 ]; then
	echo >&2 "*** ERROR: Need exactly two arguments, got $#";
	echo >&2 ""
	usageversion;
	exit 2 ;
    fi
    temp_new_file="$1";
    temp_dest_file="$2";

    if [ ! -e "${temp_new_file}" ]; then
	echo >&2 "Error: The new file ${temp_new_file} does not exist!";
	exit 1;
    fi
    setq new_file  "$(readlink -q -m $temp_new_file)"  "The new file";
    if [ -e "$temp_dest_file" ]; then
        setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file";
    else
        setq dest_file "$temp_dest_file" "The Destination file";
    fi
fi


safe_dest_file=$(echo "$dest_file" | perl -nle 'print "\Q$_\E\n"')



######################################################################
########                                                     #########
########              Set Default Values                     #########
########                                                     #########
######################################################################
# Load site defaults and over rides.
if [ -f /etc/ucf.conf ]; then
    . /etc/ucf.conf
fi

# Command line, env variable, config file, or default
if [ ! "x$opt_source_dir" = "x" ]; then
    setq source_dir "$opt_source_dir" "The Source directory"
elif [ ! "x$UCF_SOURCE_DIR" = "x" ]; then
    setq source_dir "$UCF_SOURCE_DIR" "The Source directory"
elif [ ! "x$conf_source_dir" = "x" ]; then
    setq source_dir "$conf_source_dir" "The Source directory"
else
    if [ "X$new_file" != "X" ]; then
	setq source_dir "$(dirname $new_file)" "The Source directory"
    else
	setq source_dir "/tmp" "The Source directory"
    fi

fi

if [ "X$PAGER" != "X" ] && which "$PAGER" >/dev/null 2>&1 ; then
    my_pager="$(which $PAGER)";
elif [ -s /usr/bin/pager ] &&
     [ "X$(readlink -e /usr/bin/pager || :)" != "X" ]; then
    my_pager=/usr/bin/pager
elif [ -x /usr/bin/sensible-pager ]; then
    my_pager=/usr/bin/sensible-pager
elif [ -x /bin/more ]; then
    my_pager=/bin/more
else
    my_pager=
fi


# Command line, env variable, config file, or default
if [ ! "x$opt_state_dir" = "x" ]; then
    setq statedir "$opt_state_dir" "The State directory"
elif [ ! "x$UCF_STATE_DIR" = "x" ]; then
    setq statedir "$UCF_STATE_DIR" "The State directory"
elif [ ! "x$conf_state_dir" = "x" ]; then
    setq statedir "$conf_state_dir" "The State directory"
else
    setq statedir '/var/lib/ucf'  "The State directory"
fi

# Command line, env variable, config file, or default
if [ ! "x$opt_force_conffold" = "x" ]; then
    setq force_conffold "$opt_force_conffold" "Keep the old file"
elif [ ! "x$UCF_FORCE_CONFFOLD" = "x" ]; then
    setq force_conffold "$UCF_FORCE_CONFFOLD" "Keep the old file"
elif [ ! "x$conf_force_conffold" = "x" ]; then
    setq force_conffold "$conf_force_conffold" "Keep the old file"
else
    force_conffold=''
fi

# Command line, env variable, config file, or default
if [ ! "x$opt_force_conffnew" = "x" ]; then
    setq force_conffnew "$opt_force_conffnew" "Replace the old file"
elif [ ! "x$UCF_FORCE_CONFFNEW" = "x" ]; then
    setq force_conffnew "$UCF_FORCE_CONFFNEW" "Replace the old file"
elif [ ! "x$conf_force_conffnew" = "x" ]; then
    setq force_conffnew "$conf_force_conffnew" "Replace the old file"
else
    force_conffnew=''
fi

# Command line, env variable, config file, or default
if [ ! "x$opt_force_conffmiss" = "x" ]; then
    setq force_conffmiss "$opt_force_conffmiss" "Replace any missing files"
elif [ ! "x$UCF_FORCE_CONFFMISS" = "x" ]; then
    setq force_conffmiss "$UCF_FORCE_CONFFMISS" "Replace any missing files"
elif [ ! "x$conf_force_conffmiss" = "x" ]; then
    setq force_conffmiss "$conf_force_conffmiss" "Replace any missing files"
else
    force_conffmiss=''
fi

if [ -n "$opt_old_mdsum_file" ]; then
    setq old_mdsum_file "$opt_old_mdsum_file" "The md5sum is found here"
elif [ ! "x$UCF_OLD_MDSUM_FILE" = "x" ]; then
    setq old_mdsum_file "$UCF_OLD_MDSUM_FILE" "The md5sum is found here"
elif [ ! "x$conf_old_mdsum_file" = "x" ]; then
    setq old_mdsum_file "$conf_old_mdsum_file" "Replace the old file"
elif [ ! "x${new_file}" = "x" ]; then
    old_mdsum_file="$source_dir/$(basename ${new_file}).md5sum";
else
    old_mdsum_file="";
fi


######################################################################
########                                                     #########
########               More Sanity checking                  #########
########                                                     #########
######################################################################
if [ "X$force_conffold" != "X" -a "X$force_conffnew" != "X" ]; then
    echo >&2 "Error: Only one of force_conffold and force_conffnew should";
    echo >&2 "       be set";
    exit 1;
fi

# VERBOSE of 0 is supposed to be the same as not setting VERBOSE
if [ "X$VERBOSE" = "X0" ]; then
    VERBOSE=''
fi


#
if [ -e "$statedir/hashfile" -a ! -w "$statedir/hashfile" ]; then
    echo >&2 "ucf: do not have write privilege to the state data"
    if [ "X$docmd" = "XYES" ]; then
	exit 1;
    fi
fi

if [ ! -d $statedir/cache ]; then
    $action mkdir -p $statedir/cache ;
fi

# test and see if this file exists in the database
if [ -e "$statedir/hashfile" ]; then
    if [ "X$VERBOSE" != "X" ]; then
	echo >&2 "The hash file exists"
	echo >&2 egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile"
	egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true
    fi
    lastsum=$(egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" | \
                   awk '{print $1;}' )
fi

if [ ! "x${new_file}" = "x" ]; then
    old_mdsum_dir="$source_dir/"$(basename "${new_file}")".md5sum.d";
else
    old_mdsum_dir="";
fi

cached_file="$(echo $dest_file | tr / :)"
######################################################################
########                                                     #########
########                  Debugging dump                     #########
########                                                     #########
######################################################################

if [ $DEBUG -gt 0 ]; then
    cat >&2 <<EOF
The new start file is      \`$new_file\'
The destination is         \`$dest_file\' (\`$safe_dest_file\')
The history is kept under  \'$source_dir\'
The file may be cached at \'$statedir/cache/$cached_file\'
EOF
    if [ -s "$dest_file" ]; then
	echo "The destination file exists, and has md5sum:"
	md5sum "$dest_file"
    else
	echo "The destination file does not exist."
    fi
    if [ "X$lastsum" != "X" ]; then
	echo "The old md5sum exists, and is:"
	echo "$lastsum"
    else
	echo "The old md5sum does not exist."
        if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then
            echo "However, there are historical md5sums around."
        fi
    fi
    if [ -e "$new_file" ]; then
	echo "The new file exists, and has md5sum:"
	md5sum "$new_file"
    else
	echo "The new file does not exist."
    fi
    if [ -d "$old_mdsum_dir" ]; then
	echo "The historical md5sum dir $old_mdsum_dir exists"
    elif [ -f "$old_mdsum_file" ]; then
	echo "The historical md5sum file $old_mdsum_file exists"
    else
	echo "Historical md5sums are not available"
    fi
fi

######################################################################
########                                                     #########
########        Short circuit if we are purging              #########
########                                                     #########
######################################################################

if [ "X$PURGE" = "XYES" ]; then
    if [ "X$VERBOSE" != "X" ]; then
	echo >&2 "Preparing to purge ${dest_file}"
    fi
    purge_md5sum;
    exit 0;
fi


# now we can restore $@
eval set -- "$saved"

######################################################################
########                                                     #########
########                  DebConf stuff                      #########
########                                                     #########
######################################################################

# Is debconf already running? Kinda tricky, because it will be after the
# confmodule is sourced, so only test before that.
if [ -z "$DEBCONF_ALREADY_RUNNING" ]; then
    if [ "$DEBIAN_HAS_FRONTEND" ]; then
	DEBCONF_ALREADY_RUNNING='YES'
    else
	DEBCONF_ALREADY_RUNNING='NO'
    fi
fi

export DEBCONF_ALREADY_RUNNING

if [ -z "$DEBCONF_OK" ]; then
    if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ]; then
	DEBCONF_OK='NO'
    else
	DEBCONF_OK='YES'
    fi
fi

# Time to start nagging the users who call ucf without debconf-ok
if [ "$DEBCONF_ALREADY_RUNNING"  = 'YES' ] && [ "$DEBCONF_OK" = NO ]; then
	# Commented out for now, uncomment after a while to begin nagging
	# maintainers to fix their scripts.
	cat \
<<END
*** WARNING: ucf was run from a maintainer script that uses debconf, but
             the script did not pass --debconf-ok to ucf. The maintainer
             script should be fixed to not stop debconf before calling ucf,
             and pass it this parameter. For now, ucf will revert to using
             old-style, non-debconf prompting. Ugh!

             Please inform the package maintainer about this problem.
END
fi

# Start up debconf or at least get the db_* commands available
if [ -e /usr/share/debconf/confmodule ]; then
    if test "$(id -u)" = 0; then
	. /usr/share/debconf/confmodule

	# Load our templates, just in case our template has
	# not been loaded or the Debconf DB lost or corrupted
	# since then, but only if it is OK to use debconf.
        if [ "$DEBCONF_OK" = 'YES' ]; then
            db_x_loadtemplatefile "$(dpkg-query --control-path ucf templates)" ucf
        fi
    else
        echo >&2 "$progname: Not loading confmodule, since we are not running as root."
    fi
    # Only set the title if debconf was not already running.
    # If it was running, then we do not want to clobber the
    # title used for configuring the whole package with debconf.
    if [ "$DEBCONF_ALREADY_RUNNING" = 'NO' ]; then
	if ! db_settitle ucf/title 2>/dev/null; then
      	    # Older debconf that does not support that command.
            if test "$(id -u)" = 0; then
		db_title "Modified configuration file"
            else
                echo >&2 "$progname: Not changing title, since we are not running as root."
            fi
	fi
    fi
fi



######################################################################
########                                                     #########
########                Start Processing                     #########
########                                                     #########
######################################################################

orig_new_file="$new_file"	# Since sometimes we replace the newfile below
newsum=$(md5sum "$new_file" | awk '{print $1}')

# Determine the action for the current file. The default is to ask,
# with non-replacement being the norm.
# If the config dir exists
#   if file in always overwrite, state +=1;
#   fi
#   if file in never overwrite, state +=2;
#   fi
#   if file in ask; state +=4
#   fi
#   if state == 0; then state = default
#   if state >= 4; ask
#   if state == 3;  ask
#   if state == 2; exit
#   if state == 1; then replace_conffile; exit

######################################################################
########                                                     #########
########               Do the replacement                    #########
########                                                     #########
######################################################################
# Step 1: If we have no record of this file, and dest file
#         does, We need to determine how to initialize the
#         ${old_mdsum_prefix}.old file..
if [ -e "$dest_file" ]; then
    destsum=$(md5sum "$dest_file"  | awk '{print $1}');
    if [ "X$lastsum" = "X" ]; then
#      a: If we have a directory containing historical md5sums of this
#         file in question, we should look and see if the currently
#         installed file matches any of the old md5sums; in which case
#         it can be silently replaced.
	if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then
	    if [ -d "$old_mdsum_dir"  ]; then
		for file in ${old_mdsum_dir}/*; do
		    oldsum="$(awk '{print $1}' $file)";
		    if [ "$oldsum" = "$destsum"  ]; then
			if [ "X$force_conffold" = "X" ]; then
#                           Bingo! replace, set the md5sum, and we are done
			    if [ "X$VERBOSE" != "X" ]; then
				echo >&2 \
				    "Replacing config file $dest_file with new version"
			    fi
			    replace_conf_file;
			    exit 0;
			else
			    replace_md5sum;
			    cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}"
			    exit 0;
			fi
		    fi
		done
	    elif [ -f "$old_mdsum_file" ]; then
		oldsum=$(egrep "^${destsum}" "$old_mdsum_file" || true)
		if [ "X$oldsum" != "X" ]; then
#                    Bingo
		    if [ "X$force_conffold" = "X" ]; then
			if [ "X$VERBOSE" != "X" ]; then
			    echo >&2 \
				"Replacing config file $dest_file with new version"
			fi
			replace_conf_file;
			exit 0;
		    else
			replace_md5sum;
			cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}"
			exit 0;
		    fi
		fi
	    fi
#	   Well, nothing matched. We now check to see if the
#	   maintainer has an opinion on how to set the ``md5sum of the
#	   previously installed version'', since we have no way of
#	   determining that automatically. Please note that unless
#	   there are limited number of previously released packages
#	   (like just one), the maintainer is also making a guess at
#	   this point by supplying a historical md5sum default file.
	    if [ "X$VERBOSE" != "X" ]; then
		echo >&2 "Histotical md5sums did not match."
	    fi
	    if [ -d "$old_mdsum_dir"  ]; then
		if [ -e "${old_mdsum_dir}/default" ]; then
		    if [ "X$VERBOSE" != "X" ]; then
			echo >&2 "However, a default entry exists, using it."
		    fi
		    lastsum="$(awk '{print $1;}' ${old_mdsum_dir}/default)"
		    do_replace_md5sum=1;
		fi
	    elif [ -f "$old_mdsum_file" ]; then
		oldsum=$(egrep "[[:space:]]default$" "$old_mdsum_file" | \
		    awk '{print $1;}')
		if [ "X$oldsum" != "X" ]; then
#                    Bingo
		    lastsum=$oldsum;
		    do_replace_md5sum=1;
		fi
	    fi
	fi

#       At this point, we are almost certain that either the
#       historical record of md5sums is not complete, or the user has
#       changed the configuration file. Rather than guessing and
#       chosing one of the historical md5sums, we fall through to the
#       solution used if there had been no historical md5sums
#       directory/file.
	if [ "X$lastsum" = "X" ]; then
#      b: We do not have a historical list of md5sums, or none
#         matched, and we still need to initialize the
#         ${old_mdsum_prefix}.old file. We can't determine whther or
#         not they made any changes, so we err on the side of caution
#         and ask'
	    if [ "X$VERBOSE" != "X" ]; then
		echo >&2 "No match found, we shall ask."
	    fi
	    lastsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA';
	fi # the old md5sum file does not exist, and the historical
	   # record failed
    fi # the old md5sum file does not exist (bug))
else  # "$dest_file" does not exist
# Step 2: If destfile does not exist, create it, set the file
#         "${old_mdsum_prefix}.old" to the md5sum of the new file, and we
#         are done
    if [ "X$lastsum" = "X" ]; then
        # Ok, so there is no indication that the package was ever
        # installed on this machine.
	echo >&2 ""
	echo >&2 "Creating config file $dest_file with new version"
	replace_conf_file;
	exit 0;
    elif [ "$lastsum" = "$newsum" ]; then
        # OK, new version of the file is the same as the last version
        # we saw. Since the user apparently has deleted the file,
        # nothing needs be done, unless we have been told differently
        if [ "X$force_conffmiss" != "X" ]; then
            echo >&2 ""
	    echo >&2 "Recreating deleted config file $dest_file with new version, as asked"
	    replace_conf_file;
	    exit 0;
        else
            echo >&2 "Not replacing deleted config file $dest_file";
        fi

    else
        # OK. New upstream version.
        if [ "X$force_conffmiss" != "X" ]; then
            # User has said to replace missing files, so we do so, no
            # questions asked.
            echo >&2 ""
	    echo >&2 "Recreating deleted config file $dest_file with new version, as asked"
	    replace_conf_file;
	    exit 0;
        else
            # Even though the user has deleted this file, they should
            # be asked now, unless specified otherwise.
            if [ "X$force_conffold" = "X" ]; then
                destsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA';
            else
                exit 0;
	    fi
        fi
    fi
fi

# Here, the destfile exists.

# step 3: If the old md5sum and the md5sum of the new file
#         do not match, we need to take action.
if [ "$lastsum" = "$newsum" ]; then
    if [ "X$VERBOSE" != "X" ]; then
	echo >&2 "md5sums match, nothing needs be done."
    fi
    if [ "X$do_replace_md5sum" != "X" ]; then
	replace_md5sum;
    fi
    exit 0;			# Hah. Match. We are done.
fi
#      a: If the md5sum of the dest file is the same as lastsum, replace the
#         destfile, saying we are replacing old config files
if [ "$destsum" = "$lastsum" ]; then
    if [ "X$force_conffold" = "X" ]; then
	echo >&2 "Replacing config file $dest_file with new version"
	replace_conf_file;
	exit 0;
    else
	replace_md5sum;
	cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}"
	exit 0;
    fi
else
#      b: If the md5sum of the dest file differs from lastsum, we need to ask
#         the user what action to take.
    if [ "X$force_conffnew" != "X" ]; then
	echo >&2 "Replacing config file $dest_file with new version"
	echo >&2 "since you asked for it."
        if [ "$destsum" = "$newsum" ]; then
            echo >&2 "The new and the old files are identical, AFAICS"
        else
            echo >&2 "The new and the old files are different"
        fi
	replace_conf_file;
	exit 0;
    fi
    if [ "X$force_conffold" != "X" ]; then
	replace_md5sum;
	cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}"
	exit 0;
    fi
#      c: If the destination file is the same as the new maintianer provided one,
#         we need do nothing.
    if [ "$newsum" = "$destsum" ]; then
	if [ "X$VERBOSE" != "X" ]; then
	    echo >&2 "md5sums of the file in place matches, nothing needs be done."
	fi
	replace_md5sum;
	exit 0;			# Hah. Match. We are done.
    fi


    done='NO';
    while [ "X$done" = "XNO" ]; do
	if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then
		# Use debconf to prompt.
		if [ -e "$statedir/cache/$cached_file" ] && [ "X$THREEWAY" != "X" ]; then
			templ=ucf/changeprompt_threeway
		else
			templ=ucf/changeprompt
		fi
		if [ "X$override_template" != "X" ]; then
			choices="$(db_metaget $templ Choices-C)"
			choices2="$(db_metaget $override_template Choices-C)"
			if [ "$choices" = "$choices2" ]; then
				templ=$override_template
			fi
		fi
		db_fset "$templ" seen false
		db_reset "$templ"
		db_subst "$templ" FILE "$dest_file"
		db_subst "$templ" NEW  "$new_file"
		db_subst "$templ" BASENAME "$(basename $dest_file)"
		db_input critical "$templ" || true
		if ! db_go; then
			# The current ucf interface does not provide a way for it
			# to tell its caller that the user chose to back up.
			# However, we could get here, if the caller turned on
			# debconf's backup capb. The best thing to do seems to be
			# to ignore requests to back up.
			continue
		fi
		db_get "$templ"
		ANSWER="$RET"
	else
            echo >&2 "Need debconf to interact"
            exit 2
########################################################################################
# 		# Prompt without using debconf.                                        #
# 		cat >&2 <<EOPRMT                                                       #
# Configuration file \`$dest_file'                                                     #
#  ==> File on system created by you or by a script.                                   #
#  ==> File also in package provided by package maintainer.                            #
#    What would you like to do about it ?  Your options are:                           #
#     Y or I  : install the package maintainer's version                               #
#     N or O  : keep your currently-installed version                                  #
#       D     : show the differences between the versions                              #
#       S     : show the side-by-side differences between the versions                 #
# EOPRMT                                                                               #
# 		if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then  #
# 			cat >&2 <<EOTD                                                 #
#     3 or T  : show a three way difference between current, older,                    #
#               and new versions of the file                                           #
#       M     : Do a 3 way merge between current, older,                               #
#               and new versions of the file [Very Experimental]                       #
# EOTD                                                                                 #
# 		fi                                                                     #
# 		cat >&2 <<EOPEND                                                       #
#       Z     : start a new shell to examine the situation                             #
#  The default action is to keep your current version.                                 #
# EOPEND                                                                               #
# 		if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then  #
# 			echo -n >&2 "*** " $(basename "$dest_file") \                  #
# 			    " (Y/I/N/O/D/3/T/M/Z) [default=N] ?"                       #
# 		else                                                                   #
# 			echo -n >&2 "*** " $(basename "$dest_file") \                  #
# 			    " (Y/I/N/O/D/Z) [default=N] ?"                             #
# 		fi                                                                     #
#   		read -e ANSWER </dev/tty                                               #
########################################################################################
	fi

	case "$ANSWER" in
	    install_new|y|Y|I|i)
		echo >&2 "Replacing config file $dest_file with new version"
		RETAIN_OLD=YES
		replace_conf_file;
		exit 0;
		;;
	    diff|D|d)
		DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")"
		show_diff "$DIFF"
		;;
	    sdiff|S|s)
		DIFF="$(run_diff sdiff -BbW "$dest_file" "$new_file")"
		show_diff "$DIFF"
		;;
	    diff_threeway|3|t|T)
		if [ -e "$statedir/cache/$cached_file" \
		    -a "X$THREEWAY" != "X" ]; then
                    if [ -e "$dest_file" ]; then
		        DIFF="$(diff3 -L Current -L Older -L New -A \
			    "$dest_file" "$statedir/cache/$cached_file" \
			    "$new_file")"  || true
                    else
                        DIFF="$(diff3 -L Current -L Older -L New -A \
			    /dev/null "$statedir/cache/$cached_file" \
			    "$new_file")"  || true
                    fi
		    show_diff "$DIFF"
		else
		    DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")"
		    show_diff "$DIFF"
		fi
		;;
	    merge_threeway|M|m)
		echo >&2 "Merging changes into the new version"
		if [ -e "$statedir/cache/$cached_file" \
		    -a "X$THREEWAY" != "X" ]; then
		    ret=0
		    diff3 -L Current -L Older -L New -m \
			"$dest_file" "$statedir/cache/$cached_file" \
			"$new_file" > "$dest_file.${NEW_SUFFIX}" || ret=$?
                    case "$ret" in
                        0)
		            new_file="$dest_file.${NEW_SUFFIX}"
		            RETAIN_OLD=YES
		            replace_conf_file
			    rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo'
			    exit 0
                            ;;
                        *)
			    mv "$dest_file.${NEW_SUFFIX}" "$dest_file.${ERR_SUFFIX}"
			    db_subst ucf/conflicts_found dest_file "$dest_file"
			    db_subst ucf/conflicts_found ERR_SUFFIX "${ERR_SUFFIX}"
			    db_input critical ucf/conflicts_found || true
			    db_go || true
			    ;;
                    esac
		else
		    replace_conf_file
		    rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo'
		    exit 0
		fi
		;;
	    shell|Z|z)
                # We explicitly connect STDIN and STDOUT to the
                # script's controlling terminal, so even if STDIN is
                # fed by a pipe, as is the case when run from
                # /usr/bin/debconf, the shell should be fully
                # functional. However, the test for a controlling
                # terminal uses /usr/bin/tty, which consults only
                # STDIN. As far as I can tell, when run from debconf,
                # ucf will _never_ use the current terminal. If the
                # goal is to check for access to a terminal, the test
                # should be for foreground process group membership,
                # not a terminal connected to STDIN (tty -s), and not
                # a terminal it doesn't necessarily own (tty -s
                # </dev/tty). The easiest way do this from a shell is
                # probably with /bin/ps.
                if ps -o stat= --ppid $$ | grep -q '+'; then
		    bash >/dev/tty </dev/tty || true
                elif [ -n "$DISPLAY" ]; then
                    x-terminal-emulator || true
                else
                    # Don't know what to do
                    echo >&2 "No terminal, and no DISPLAY set, can't fork shell."
                    sleep 3;
                fi
		;;
	    keep_current|n|N|o|O|'')
		replace_md5sum;

		cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}"
		exit 0;
		;;
	    *)
		if [ "$DEBCONF_OK" = "YES" ]; then
			echo "Error: unknown response from debconf:'$RET'" >&2
			exit 1
		else
			echo
			echo "Please answer with one of the single letters listed." >&2
			echo
		fi
	esac
    done
fi

db_stop

exit 0;

Filemanager

Name Type Size Permission Actions
X11 Folder 0755
2to3-2.7 File 96 B 0755
7z File 39 B 0755
7za File 40 B 0755
7zr File 40 B 0755
GET File 15.84 KB 0755
HEAD File 15.84 KB 0755
NF File 963 B 0755
POST File 15.84 KB 0755
Thunar File 755.85 KB 0755
VGAuthService File 126.22 KB 0755
X File 274 B 0755
Xorg File 274 B 0755
[ File 50.18 KB 0755
aa-enabled File 22.16 KB 0755
aa-exec File 22.16 KB 0755
ab File 54.18 KB 0755
aclocal File 35.93 KB 0755
aclocal-1.15 File 35.93 KB 0755
acpi_listen File 14.27 KB 0755
add-apt-repository File 7.24 KB 0755
addpart File 22.08 KB 0755
addr2line File 30.55 KB 0755
ambiguous_words File 10.09 KB 0755
apport-bug File 2.5 KB 0755
apport-cli File 13.05 KB 0755
apport-collect File 2.5 KB 0755
apport-unpack File 1.81 KB 0755
appres File 9.99 KB 0755
apropos File 46.98 KB 0755
apt File 14.09 KB 0755
apt-add-repository File 7.24 KB 0755
apt-cache File 78.16 KB 0755
apt-cdrom File 22.16 KB 0755
apt-config File 22.09 KB 0755
apt-extracttemplates File 22.16 KB 0755
apt-ftparchive File 234.16 KB 0755
apt-get File 42.16 KB 0755
apt-key File 26.75 KB 0755
apt-mark File 42.16 KB 0755
apt-sortpkgs File 42.09 KB 0755
ar File 58.24 KB 0755
arch File 34.21 KB 0755
arping File 22 KB 4755
as File 895.98 KB 0755
aspell File 150.34 KB 0755
aspell-import File 2 KB 0755
at File 50.26 KB 6755
atobm File 13.99 KB 0755
atq File 50.26 KB 6755
atrm File 50.26 KB 6755
autoconf File 14.42 KB 0755
autoheader File 8.34 KB 0755
autom4te File 31.91 KB 0755
automake File 247.38 KB 0755
automake-1.15 File 247.38 KB 0755
automat-visualize3 File 402 B 0755
autopoint File 25.97 KB 0755
autoreconf File 20.67 KB 0755
autoscan File 16.73 KB 0755
autoupdate File 33.08 KB 0755
awk File 642.65 KB 0755
b2sum File 54.21 KB 0755
base32 File 38.18 KB 0755
base64 File 38.18 KB 0755
basename File 34.18 KB 0755
bashbug File 6.95 KB 0755
batch File 152 B 0755
bc File 90.7 KB 0755
bdftopcf File 42.12 KB 0755
bdftruncate File 9.99 KB 0755
bitmap File 98.09 KB 0755
bmtoa File 10.02 KB 0755
bootctl File 34.13 KB 0755
broadwayd File 114.08 KB 0755
browse File 24.65 KB 0755
bsd-from File 9.99 KB 0755
bsd-write File 13.99 KB 2755
busctl File 66.09 KB 0755
byobu File 8.07 KB 0755
byobu-config File 996 B 0755
byobu-ctrl-a File 4.66 KB 0755
byobu-disable File 1.26 KB 0755
byobu-disable-prompt File 1.28 KB 0755
byobu-enable File 1.15 KB 0755
byobu-enable-prompt File 1.42 KB 0755
byobu-export File 1.23 KB 0755
byobu-janitor File 5.82 KB 0755
byobu-keybindings File 1.47 KB 0755
byobu-launch File 3.21 KB 0755
byobu-launcher File 1.87 KB 0755
byobu-launcher-install File 2.4 KB 0755
byobu-launcher-uninstall File 1.52 KB 0755
byobu-layout File 3.27 KB 0755
byobu-prompt File 1.13 KB 0755
byobu-quiet File 1.38 KB 0755
byobu-reconnect-sockets File 3.22 KB 0755
byobu-screen File 8.07 KB 0755
byobu-select-backend File 1.42 KB 0755
byobu-select-profile File 6.14 KB 0755
byobu-select-session File 1012 B 0755
byobu-shell File 1.56 KB 0755
byobu-silent File 1.28 KB 0755
byobu-status File 5.87 KB 0755
byobu-status-detail File 1.18 KB 0755
byobu-tmux File 8.07 KB 0755
byobu-ugraph File 4.56 KB 0755
byobu-ulevel File 11.71 KB 0755
c++ File 1022.94 KB 0755
c++filt File 26.12 KB 0755
c89 File 428 B 0755
c89-gcc File 428 B 0755
c99 File 454 B 0755
c99-gcc File 454 B 0755
c_rehash File 6.65 KB 0755
cal File 28.79 KB 0755
calendar File 30.48 KB 0755
captoinfo File 82.11 KB 0755
catchsegv File 3.25 KB 0755
catman File 38.46 KB 0755
cautious-launcher File 853 B 0755
cc File 1022.94 KB 0755
certbot File 385 B 0755
cftp3 File 380 B 0755
cgroupfs-mount File 1.25 KB 0755
cgroupfs-umount File 620 B 0755
chacl File 13.99 KB 0755
chage File 70.13 KB 2755
chardet File 387 B 0755
chardet3 File 389 B 0755
chardetect File 387 B 0755
chardetect3 File 389 B 0755
chattr File 14 KB 0755
chcon File 62.18 KB 0755
check-language-support File 2.71 KB 0755
checkgid File 5.99 KB 0755
chfn File 74.7 KB 4755
chrt File 30.08 KB 0755
chsh File 43.48 KB 4755
cjpeg File 34.07 KB 0755
ckbcomp File 146.33 KB 0755
ckeygen3 File 386 B 0755
cksum File 34.18 KB 0755
classifier_tester File 50.23 KB 0755
clear File 10 KB 0755
clear_console File 10.07 KB 0755
cloud-id File 396 B 0755
cloud-init File 400 B 0755
cloud-init-per File 2.06 KB 0755
cmdtest File 8.16 KB 0755
cmp File 46.09 KB 0755
cntraining File 50.26 KB 0755
codepage File 13.99 KB 0755
col File 9.99 KB 0755
col1 File 963 B 0755
col2 File 963 B 0755
col3 File 963 B 0755
col4 File 963 B 0755
col5 File 963 B 0755
col6 File 963 B 0755
col7 File 963 B 0755
col8 File 963 B 0755
col9 File 963 B 0755
colcrt File 10 KB 0755
colrm File 9.99 KB 0755
column File 14.01 KB 0755
combine_lang_model File 102.16 KB 0755
combine_tessdata File 14.16 KB 0755
comm File 38.21 KB 0755
compose File 17.74 KB 0755
conch3 File 382 B 0755
containerd File 52.17 MB 0755
containerd-shim File 7.11 MB 0755
containerd-shim-runc-v1 File 9.2 MB 0755
containerd-shim-runc-v2 File 9.23 MB 0755
containerd-stress File 22.52 MB 0755
corelist File 12.53 KB 0755
cpan File 7.96 KB 0755
cpan5.26-x86_64-linux-gnu File 7.99 KB 0755
cpp File 1022.94 KB 0755
cpp-7 File 1022.94 KB 0755
cpp-8 File 1.01 MB 0755
crontab File 38.43 KB 2755
csplit File 50.21 KB 0755
ctail File 958 B 0755
ctr File 26.5 MB 0755
ctstat File 22.35 KB 0755
curl File 218.07 KB 0755
cut File 42.21 KB 0755
cvt File 13.99 KB 0755
dawg2wordlist File 14.16 KB 0755
dbilogstrip File 1.35 KB 0755
dbiprof File 6.06 KB 0755
dbiproxy File 5.27 KB 0755
dbus-cleanup-sockets File 9.98 KB 0755
dbus-daemon File 231.04 KB 0755
dbus-launch File 25.99 KB 0755
dbus-monitor File 21.99 KB 0755
dbus-run-session File 9.98 KB 0755
dbus-send File 25.98 KB 0755
dbus-update-activation-environment File 13.98 KB 0755
dbus-uuidgen File 9.98 KB 0755
deallocvt File 10.07 KB 0755
deb-systemd-helper File 19.67 KB 0755
deb-systemd-invoke File 4.33 KB 0755
debconf File 2.79 KB 0755
debconf-apt-progress File 11.27 KB 0755
debconf-communicate File 608 B 0755
debconf-copydb File 1.68 KB 0755
debconf-escape File 647 B 0755
debconf-gettextize File 15.97 KB 0755
debconf-set-selections File 2.87 KB 0755
debconf-show File 1.78 KB 0755
debconf-updatepo File 4.46 KB 0755
debian-distro-info File 18.59 KB 0755
delpart File 22.08 KB 0755
delv File 40.86 KB 0755
derb File 22.57 KB 0755
desktop-file-edit File 88.03 KB 0755
desktop-file-install File 88.03 KB 0755
desktop-file-validate File 76.26 KB 0755
dh_autotools-dev_restoreconfig File 1.79 KB 0755
dh_autotools-dev_updateconfig File 1.81 KB 0755
dh_bash-completion File 2.49 KB 0755
dh_perl_dbi File 1.04 KB 0755
dh_perl_openssl File 1.36 KB 0755
dh_pypy File 12.58 KB 0755
dh_python2 File 1.03 KB 0755
dh_python3 File 12.78 KB 0755
dialog File 230.03 KB 0755
diff File 142.34 KB 0755
diff3 File 62.21 KB 0755
dig File 146.51 KB 0755
dircolors File 46.19 KB 0755
dirmngr File 533.55 KB 0755
dirmngr-client File 106.76 KB 0755
dirname File 30.18 KB 0755
distro-info File 18.59 KB 0755
djpeg File 34.07 KB 0755
do-release-upgrade File 9.39 KB 0755
docker File 48.44 MB 0755
docker-init File 785.91 KB 0755
docker-proxy File 2.45 MB 0755
dockerd File 81.04 MB 0755
dpkg File 290.5 KB 0755
dpkg-architecture File 12.55 KB 0755
dpkg-buildflags File 7.39 KB 0755
dpkg-buildpackage File 29.1 KB 0755
dpkg-checkbuilddeps File 7.33 KB 0755
dpkg-deb File 150.34 KB 0755
dpkg-distaddfile File 2.72 KB 0755
dpkg-divert File 138.41 KB 0755
dpkg-genbuildinfo File 16.38 KB 0755
dpkg-genchanges File 17.21 KB 0755
dpkg-gencontrol File 13.73 KB 0755
dpkg-gensymbols File 10.38 KB 0755
dpkg-maintscript-helper File 18.58 KB 0755
dpkg-mergechangelogs File 8.39 KB 0755
dpkg-name File 6.63 KB 0755
dpkg-parsechangelog File 4.33 KB 0755
dpkg-query File 146.4 KB 0755
dpkg-scanpackages File 8.23 KB 0755
dpkg-scansources File 8.95 KB 0755
dpkg-shlibdeps File 30.63 KB 0755
dpkg-source File 22.75 KB 0755
dpkg-split File 118.34 KB 0755
dpkg-statoverride File 70.25 KB 0755
dpkg-trigger File 66.26 KB 0755
dpkg-vendor File 3.19 KB 0755
du File 98.21 KB 0755
dumpkeys File 166.52 KB 0755
dvipdf File 1023 B 0755
dwp File 2.75 MB 0755
eatmydata File 2.74 KB 0755
ec2metadata File 7.13 KB 0755
edit File 17.74 KB 0755
editor File 240.11 KB 0755
editres File 68.4 KB 0755
eject File 30.69 KB 0755
elfedit File 30.45 KB 0755
enc2xs File 41.17 KB 0755
encguess File 2.99 KB 0755
enchant File 18.07 KB 0755
enchant-lsmod File 9.99 KB 0755
env File 34.18 KB 0755
envsubst File 34.08 KB 0755
eps2eps File 639 B 0755
eqn File 193.19 KB 0755
ex File 2.55 MB 0755
exifautotran File 1.11 KB 0755
exo-csource File 14.09 KB 0755
exo-desktop-item-edit File 70.55 KB 0755
exo-open File 18.32 KB 0755
exo-preferred-applications File 296 B 0755
expand File 38.21 KB 0755
expiry File 22.27 KB 2755
expr File 46.18 KB 0755
factor File 74.21 KB 0755
faillog File 18.29 KB 0755
faked-sysv File 26.11 KB 0755
faked-tcp File 30.1 KB 0755
fakeroot File 3.76 KB 0755
fakeroot-sysv File 3.76 KB 0755
fakeroot-tcp File 3.76 KB 0755
fallocate File 26.08 KB 0755
fc-cache File 14.07 KB 0755
fc-cat File 14.07 KB 0755
fc-list File 10.07 KB 0755
fc-match File 10.07 KB 0755
fc-pattern File 10.07 KB 0755
fc-query File 10.07 KB 0755
fc-scan File 10.07 KB 0755
fc-validate File 10.07 KB 0755
fcgistarter File 9.99 KB 0755
ffmpeg File 266.14 KB 0755
ffplay File 134.16 KB 0755
ffprobe File 158.15 KB 0755
ffserver File 139.27 KB 0755
file File 22.26 KB 0755
find File 232.5 KB 0755
flock File 30.16 KB 0755
fmt File 42.18 KB 0755
fold File 34.18 KB 0755
fonttosfnt File 34.02 KB 0755
free File 18.08 KB 0755
freetype-config File 4.62 KB 0755
from File 9.99 KB 0755
ftp File 98.7 KB 0755
funzip File 21.99 KB 0755
futurize File 384 B 0755
g++ File 1022.94 KB 0755
g++-7 File 1022.94 KB 0755
gapplication File 18.07 KB 0755
gawk File 642.65 KB 0755
gcc File 1022.94 KB 0755
gcc-7 File 1022.94 KB 0755
gcc-8 File 1.01 MB 0755
gcc-ar File 30.47 KB 0755
gcc-ar-7 File 30.47 KB 0755
gcc-ar-8 File 26.47 KB 0755
gcc-nm File 30.47 KB 0755
gcc-nm-7 File 30.47 KB 0755
gcc-nm-8 File 26.47 KB 0755
gcc-ranlib File 30.47 KB 0755
gcc-ranlib-7 File 30.47 KB 0755
gcc-ranlib-8 File 26.47 KB 0755
gccgo-8 File 1.01 MB 0755
gconf-merge-tree File 54.08 KB 0755
gconftool File 62.07 KB 0755
gconftool-2 File 62.07 KB 0755
gcov File 616.09 KB 0755
gcov-7 File 616.09 KB 0755
gcov-8 File 640.09 KB 0755
gcov-dump File 499.93 KB 0755
gcov-dump-7 File 499.93 KB 0755
gcov-dump-8 File 491.95 KB 0755
gcov-tool File 535.99 KB 0755
gcov-tool-7 File 535.99 KB 0755
gcov-tool-8 File 512.02 KB 0755
gdbus File 42.08 KB 0755
gdbus-codegen File 2 KB 0755
gdebi File 3.94 KB 0755
gdk-pixbuf-thumbnailer File 14.08 KB 0755
genbrk File 14.48 KB 0755
gencat File 22.22 KB 0755
gencfu File 10.43 KB 0755
gencnval File 22.32 KB 0755
gendict File 22.55 KB 0755
genrb File 123.59 KB 0755
geqn File 193.19 KB 0755
getconf File 30.13 KB 0755
getent File 30.49 KB 0755
getfacl File 22.62 KB 0755
getkeycodes File 10.07 KB 0755
getopt File 14.07 KB 0755
gettext File 34.08 KB 0755
gettext.sh File 4.52 KB 0755
gettextize File 42.73 KB 0755
ghostscript File 9.99 KB 0755
ginstall-info File 43.09 KB 0755
gio File 78.09 KB 0755
gio-querymodules File 9.99 KB 0755
git File 2.27 MB 0755
git-receive-pack File 2.27 MB 0755
git-shell File 1.26 MB 0755
git-upload-archive File 2.27 MB 0755
git-upload-pack File 1.27 MB 0755
glib-compile-resources File 38.07 KB 0755
glib-compile-schemas File 42.07 KB 0755
glib-genmarshal File 39.97 KB 0755
glib-gettextize File 5.25 KB 0755
glib-mkenums File 27.15 KB 0755
globaltime File 82.05 KB 0755
gnome-help File 54.07 KB 0755
gnome-terminal File 3.33 KB 0755
gnome-terminal.real File 94.84 KB 0755
gnome-terminal.wrapper File 2.36 KB 0755
go File 1.76 MB 0755
go-8 File 1.76 MB 0755
gobject-query File 10 KB 0755
gofmt File 127.6 KB 0755
gofmt-8 File 127.6 KB 0755
gold File 2.97 MB 0755
gpasswd File 74.05 KB 4755
gpg File 997.6 KB 0755
gpg-agent File 392.7 KB 0755
gpg-connect-agent File 154.85 KB 0755
gpg-wks-server File 187.02 KB 0755
gpg-zip File 3.36 KB 0755
gpgconf File 166.32 KB 0755
gpgparsemail File 26.07 KB 0755
gpgsm File 491.09 KB 0755
gpgsplit File 78.45 KB 0755
gpgv File 427.02 KB 0755
gpic File 204.03 KB 0755
gprof File 99.73 KB 0755
grafana-agent File 177.48 MB 0755
grafana-agentctl File 161.58 MB 0755
gresource File 17.99 KB 0755
groff File 105.31 KB 0755
grog File 2.71 KB 0755
grops File 165.72 KB 0755
grotty File 121.34 KB 0755
groups File 34.18 KB 0755
growpart File 21.37 KB 0755
grub-editenv File 239.93 KB 0755
grub-file File 659.79 KB 0755
grub-fstest File 789.65 KB 0755
grub-glue-efi File 235.77 KB 0755
grub-kbdcomp File 1.64 KB 0755
grub-menulst2cfg File 216.04 KB 0755
grub-mkfont File 264.34 KB 0755
grub-mkimage File 328.84 KB 0755
grub-mklayout File 240.09 KB 0755
grub-mknetdir File 373.41 KB 0755
grub-mkpasswd-pbkdf2 File 244.12 KB 0755
grub-mkrelpath File 235.49 KB 0755
grub-mkrescue File 822.23 KB 0755
grub-mkstandalone File 449.74 KB 0755
grub-mount File 608.21 KB 0755
grub-render-label File 676.16 KB 0755
grub-script-check File 259.62 KB 0755
grub-syslinux2cfg File 624.68 KB 0755
gs File 9.99 KB 0755
gsbj File 350 B 0755
gsdj File 352 B 0755
gsdj500 File 352 B 0755
gsettings File 26.07 KB 0755
gsettings-data-convert File 21.99 KB 0755
gsettings-schema-convert File 40.83 KB 0755
gslj File 353 B 0755
gslp File 350 B 0755
gsnd File 277 B 0755
gtbl File 126.2 KB 0755
gtester File 22.01 KB 0755
gtester-report File 18.39 KB 0755
gtf File 13.99 KB 0755
gtk-builder-tool File 26.42 KB 0755
gtk-launch File 14.15 KB 0755
gtk-query-settings File 9.99 KB 0755
gtk-update-icon-cache File 30.47 KB 0755
h2ph File 28.54 KB 0755
h2xs File 59.44 KB 0755
hd File 26.1 KB 0755
head File 42.21 KB 0755
helpztags File 2.46 KB 0755
hexdump File 26.1 KB 0755
host File 126.66 KB 0755
hostid File 30.18 KB 0755
hostnamectl File 18.07 KB 0755
htcacheclean File 30 KB 0755
htdbm File 21.99 KB 0755
htdigest File 13.99 KB 0755
htop File 180.68 KB 0755
htpasswd File 17.99 KB 0755
hwe-support-status File 10.58 KB 0755
i386 File 18.34 KB 0755
i686-linux-gnu-pkg-config File 2.06 KB 0755
iceauth File 38.12 KB 0755
ico File 48.13 KB 0755
iconv File 62.25 KB 0755
icu-config File 21.66 KB 0755
icuinfo File 10.32 KB 0755
id File 42.21 KB 0755
ifnames File 4.03 KB 0755
igawk File 3.11 KB 0755
info File 245.72 KB 0755
infobrowser File 245.72 KB 0755
infocmp File 58.07 KB 0755
infotocap File 82.11 KB 0755
innochecksum File 3.52 MB 0755
install File 142.25 KB 0755
install-info File 43.09 KB 0755
instmodsh File 4.27 KB 0755
intel-virtual-output File 65.99 KB 0755
ionice File 26.08 KB 0755
ipcmk File 26.14 KB 0755
ipcrm File 26.08 KB 0755
ipcs File 50.08 KB 0755
iptables-xml File 92.74 KB 0755
ischroot File 10.04 KB 0755
iscsiadm File 381.95 KB 0755
isdv4-serial-debugger File 18.02 KB 0755
isdv4-serial-inputattach File 18.02 KB 0755
ispell-wrapper File 7.05 KB 0755
join File 46.21 KB 0755
jpegexiforient File 9.99 KB 0755
jpegtran File 29.99 KB 0755
json_pp File 3.87 KB 0755
jsondiff File 1018 B 0755
jsonpatch File 3.58 KB 0755
jsonpointer File 1.31 KB 0755
jsonschema File 398 B 0755
kbdinfo File 14.07 KB 0755
kbxutil File 158.69 KB 0755
keep-one-running File 3.51 KB 0755
kernel-install File 4.4 KB 0755
keyring File 385 B 0755
killall File 27.12 KB 0755
kmodsign File 14.13 KB 0755
landscape-sysinfo File 624 B 0755
last File 42.08 KB 0755
lastb File 42.08 KB 0755
lastlog File 18.07 KB 0755
lcf File 7.6 KB 0755
ld File 1.7 MB 0755
ld.bfd File 1.7 MB 0755
ld.gold File 2.97 MB 0755
ldd File 5.29 KB 0755
less File 166.76 KB 0755
lessecho File 10.02 KB 0755
lessfile File 8.36 KB 0755
lesskey File 19.39 KB 0755
lesspipe File 8.36 KB 0755
letsencrypt File 385 B 0755
lexgrog File 90.57 KB 0755
libnetcfg File 15.41 KB 0755
libpng-config File 2.41 KB 0755
libpng16-config File 2.41 KB 0755
libtoolize File 126.16 KB 0755
libwacom-list-local-devices File 10.1 KB 0755
link File 30.18 KB 0755
linux-boot-prober File 1.54 KB 0755
linux-check-removal File 3.99 KB 0755
linux-update-symlinks File 6.17 KB 0755
linux-version File 2.63 KB 0755
linux32 File 18.34 KB 0755
linux64 File 18.34 KB 0755
listres File 10.41 KB 0755
lnstat File 22.35 KB 0755
loadkeys File 206.57 KB 0755
loadunimap File 26.13 KB 0755
locale File 49.41 KB 0755
locale-check File 10 KB 0755
localectl File 22.07 KB 0755
localedef File 330.8 KB 0755
locate File 42.08 KB 2755
logger File 46.67 KB 0755
logname File 30.18 KB 0755
logresolve File 10 KB 0755
look File 10.23 KB 0755
lorder File 2.82 KB 0755
lsattr File 10 KB 0755
lsb_release File 3.55 KB 0755
lscpu File 70.08 KB 0755
lshw File 682.95 KB 0755
lsinitramfs File 625 B 0755
lsipc File 70.08 KB 0755
lslocks File 34.41 KB 0755
lslogins File 62.08 KB 0755
lsmem File 42.08 KB 0755
lsns File 38.08 KB 0755
lsof File 159.4 KB 0755
lspci File 79.67 KB 0755
lspgpot File 1.06 KB 0755
lstmeval File 62.2 KB 0755
lstmtraining File 74.2 KB 0755
lsusb File 114.43 KB 0755
ltrace File 325.21 KB 0755
luit File 48.12 KB 0755
lwp-download File 10.05 KB 0755
lwp-dump File 2.65 KB 0755
lwp-mirror File 2.36 KB 0755
lwp-request File 15.84 KB 0755
lxc File 10.28 MB 0755
lxcfs File 18.07 KB 0755
lxd File 105 B 0755
lzcat File 74.36 KB 0755
lzcmp File 6.48 KB 0755
lzdiff File 6.48 KB 0755
lzegrep File 5.76 KB 0755
lzfgrep File 5.76 KB 0755
lzgrep File 5.76 KB 0755
lzless File 1.76 KB 0755
lzma File 74.36 KB 0755
lzmainfo File 10.07 KB 0755
lzmore File 2.11 KB 0755
m4 File 154.3 KB 0755
make File 217.57 KB 0755
make-first-existing-target File 4.79 KB 0755
makeconv File 46.77 KB 0755
man File 104.5 KB 0755
mandb File 126.72 KB 0755
manifest File 1.9 KB 0755
manpath File 30.47 KB 0755
mapscrn File 22.13 KB 0755
markdown_py File 1013 B 0755
mawk File 122.48 KB 0755
mcookie File 30.14 KB 0755
md5sum File 42.21 KB 0755
md5sum.textutils File 42.21 KB 0755
mdig File 42.13 KB 0755
merge_unicharsets File 10.09 KB 0755
mesg File 10.07 KB 0755
mftraining File 62.2 KB 0755
migrate-pubring-from-classic-gpg File 2.14 KB 0755
mimeopen File 8.42 KB 0755
mimetype File 11.81 KB 0755
miniterm File 34.28 KB 0755
mk_modmap File 15.78 KB 0755
mkfifo File 62.18 KB 0755
mkfontdir File 65 B 0755
mkfontscale File 38.52 KB 0755
mksquashfs File 184.99 KB 0755
mlocate File 42.08 KB 2755
mmcli File 199.82 KB 0755
mokutil File 55.4 KB 0755
mousepad File 262.15 KB 0755
msgattrib File 22.07 KB 0755
msgcat File 22.07 KB 0755
msgcmp File 22.08 KB 0755
msgcomm File 22.07 KB 0755
msgconv File 18.07 KB 0755
msgen File 18.07 KB 0755
msgexec File 14.07 KB 0755
msgfilter File 26.07 KB 0755
msgfmt File 78.27 KB 0755
msggrep File 34.19 KB 0755
msginit File 62.41 KB 0755
msgmerge File 66.45 KB 0755
msgunfmt File 30.09 KB 0755
msguniq File 18.07 KB 0755
mtr File 71.94 KB 0755
mtr-packet File 25.99 KB 0755
mtrace File 6.34 KB 0755
my_print_defaults File 3.45 MB 0755
myisam_ftdump File 3.75 MB 0755
myisamchk File 3.85 MB 0755
myisamlog File 3.73 MB 0755
myisampack File 3.78 MB 0755
mysql File 3.81 MB 0755
mysql_config_editor File 3.46 MB 0755
mysql_embedded File 21.17 MB 0755
mysql_install_db File 5.01 MB 0755
mysql_plugin File 3.45 MB 0755
mysql_secure_installation File 3.69 MB 0755
mysql_ssl_rsa_setup File 3.49 MB 0755
mysql_tzinfo_to_sql File 3.4 MB 0755
mysql_upgrade File 4.32 MB 0755
mysqladmin File 3.71 MB 0755
mysqlanalyze File 3.73 MB 0755
mysqlbinlog File 3.96 MB 0755
mysqlcheck File 3.73 MB 0755
mysqld_multi File 26.3 KB 0755
mysqld_safe File 27.16 KB 0755
mysqldump File 3.78 MB 0755
mysqldumpslow File 7.66 KB 0755
mysqlimport File 3.7 MB 0755
mysqloptimize File 3.73 MB 0755
mysqlpump File 4.17 MB 0755
mysqlrepair File 3.73 MB 0755
mysqlreport File 38.1 KB 0755
mysqlshow File 3.7 MB 0755
mysqlslap File 3.71 MB 0755
mysqltuner File 208.31 KB 0755
mytop File 59.58 KB 0755
namei File 26.08 KB 0755
nawk File 642.65 KB 0755
ncal File 28.79 KB 0755
neqn File 908 B 0755
netkit-ftp File 98.7 KB 0755
networkd-dispatcher File 19.53 KB 0755
newgidmap File 36.27 KB 4755
newgrp File 39.4 KB 4755
newuidmap File 36.27 KB 4755
ngettext File 34.08 KB 0755
nice File 34.18 KB 0755
nl File 42.27 KB 0755
nm File 43.27 KB 0755
nm-online File 13.98 KB 0755
nmcli File 678.7 KB 0755
nmtui File 243.31 KB 0755
nmtui-connect File 243.31 KB 0755
nmtui-edit File 243.31 KB 0755
nmtui-hostname File 243.31 KB 0755
nohup File 34.18 KB 0755
notify-send File 14.09 KB 0755
nproc File 34.18 KB 0755
nroff File 3.25 KB 0755
nsenter File 30.28 KB 0755
nslookup File 130.51 KB 0755
nstat File 26.07 KB 0755
nsupdate File 66.02 KB 0755
ntfsdecrypt File 46.12 KB 0755
numfmt File 62.24 KB 0755
objcopy File 230.2 KB 0755
objdump File 404.55 KB 0755
oclock File 23.34 KB 0755
od File 66.21 KB 0755
on_ac_power File 2.16 KB 0755
openssl File 706.98 KB 0755
orage File 330.79 KB 0755
os-prober File 4.44 KB 0755
p7zip File 4.64 KB 0755
pacat File 42.11 KB 0755
pacmd File 18.07 KB 0755
pactl File 62.09 KB 0755
padsp File 2.21 KB 0755
pager File 166.76 KB 0755
pamon File 42.11 KB 0755
paperconf File 9.99 KB 0755
paplay File 42.11 KB 0755
parec File 42.11 KB 0755
parecord File 42.11 KB 0755
partx File 86.08 KB 0755
passwd File 58.24 KB 4755
paste File 34.21 KB 0755
pastebinit File 16.25 KB 0755
pasteurize File 388 B 0755
pasuspender File 14.08 KB 0755
patch File 178.37 KB 0755
pathchk File 34.18 KB 0755
pavucontrol File 442.2 KB 0755
pax11publish File 13.99 KB 0755
pbget File 2.51 KB 0755
pbput File 2.51 KB 0755
pbputs File 2.51 KB 0755
pbr File 152 B 0755
pcimodules File 14.13 KB 0755
pcre-config File 2.29 KB 0755
pdb File 45.02 KB 0755
pdb2.7 File 45.02 KB 0755
pdb3 File 59.87 KB 0755
pdb3.6 File 59.87 KB 0755
pdf2dsc File 698 B 0755
pdf2ps File 909 B 0755
pear File 793 B 0755
peardev File 814 B 0755
pecl File 727 B 0755
peekfd File 13.99 KB 0755
perl File 2 MB 0755
perl5.26-x86_64-linux-gnu File 9.98 KB 0755
perl5.26.1 File 2 MB 0755
perlbug File 44.78 KB 0755
perldoc File 125 B 0755
perlivp File 10.61 KB 0755
perlthanks File 44.78 KB 0755
perror File 3.58 MB 0755
pf2afm File 498 B 0755
pfbtopfa File 516 B 0755
pftp File 98.7 KB 0755
pgrep File 26.09 KB 0755
phar File 14.47 KB 0755
phar.phar File 14.47 KB 0755
phar.phar7.0 File 14.48 KB 0755
phar.phar7.2 File 14.47 KB 0755
phar7.0 File 14.48 KB 0755
phar7.2 File 14.47 KB 0755
php File 4.68 MB 0755
php File 36.89 MB 0755
php7.0 File 4.2 MB 0755
php7.2 File 4.68 MB 0755
pic File 204.03 KB 0755
pico File 240.11 KB 0755
piconv File 8.16 KB 0755
pigz File 114.2 KB 0755
pinentry File 62.49 KB 0755
pinentry-curses File 62.49 KB 0755
pinky File 38.21 KB 0755
pip3 File 293 B 0755
pkaction File 13.99 KB 0755
pkcheck File 18.07 KB 0755
pkexec File 21.99 KB 4755
pkg-config File 50.09 KB 0755
pkgdata File 43.22 KB 0755
pkill File 26.09 KB 0755
pkttyagent File 13.99 KB 0755
pl2pm File 4.43 KB 0755
pldd File 14.22 KB 0755
plog File 146 B 0755
pmap File 30.09 KB 0755
png-fix-itxt File 9.99 KB 0755
pngfix File 46.08 KB 0755
po2debconf File 8.47 KB 0755
pod2html File 4.04 KB 0755
pod2man File 14.73 KB 0755
pod2text File 10.72 KB 0755
pod2usage File 3.86 KB 0755
podchecker File 3.57 KB 0755
podebconf-display-po File 12.67 KB 0755
podebconf-report-po File 31.76 KB 0755
podselect File 2.47 KB 0755
poff File 2.77 KB 0755
pollinate File 8.54 KB 0755
pon File 1.33 KB 0755
pphs File 404 B 0755
pr File 70.27 KB 0755
precat File 5.52 KB 0755
preconv File 46.2 KB 0755
preunzip File 5.52 KB 0755
prezip File 5.52 KB 0755
prezip-bin File 9.99 KB 0755
print File 17.74 KB 0755
printafm File 395 B 0755
printenv File 30.18 KB 0755
printerbanner File 22 KB 0755
printf File 50.18 KB 0755
prlimit File 34.59 KB 0755
pro File 442 B 0755
protonvpn-cli File 415 B 0755
prove File 13.27 KB 0755
prtstat File 18.07 KB 0755
ps2ascii File 631 B 0755
ps2epsi File 2.69 KB 0755
ps2pdf File 272 B 0755
ps2pdf12 File 215 B 0755
ps2pdf13 File 215 B 0755
ps2pdf14 File 215 B 0755
ps2pdfwr File 1.07 KB 0755
ps2ps File 647 B 0755
ps2ps2 File 669 B 0755
ps2txt File 631 B 0755
psfaddtable File 17.99 KB 0755
psfgettable File 17.99 KB 0755
psfstriptable File 17.99 KB 0755
psfxtable File 17.99 KB 0755
pslog File 9.99 KB 0755
pspell-config File 374 B 0755
pstree File 26.95 KB 0755
pstree.x11 File 26.95 KB 0755
ptar File 3.47 KB 0755
ptardiff File 2.57 KB 0755
ptargrep File 4.29 KB 0755
ptx File 70.24 KB 0755
pulseaudio File 90.16 KB 0755
purge-old-kernels File 1.12 KB 0755
pwdx File 10.07 KB 0755
py3clean File 7.63 KB 0755
py3compile File 11.83 KB 0755
py3versions File 11.44 KB 0755
pybuild File 25.03 KB 0755
pyclean File 4.03 KB 0755
pycompile File 11.62 KB 0755
pydoc File 79 B 0755
pydoc2.7 File 79 B 0755
pydoc3 File 79 B 0755
pydoc3.6 File 79 B 0755
pygettext File 21.56 KB 0755
pygettext2.7 File 21.56 KB 0755
pygettext3 File 21.04 KB 0755
pygettext3.6 File 21.04 KB 0755
pygmentize File 149 B 0755
pyhtmlizer3 File 392 B 0755
pyjwt3 File 372 B 0755
python File 3.47 MB 0755
python2 File 3.47 MB 0755
python2.7 File 3.47 MB 0755
python3 File 4.32 MB 0755
python3-config File 3.21 KB 0755
python3-futurize File 384 B 0755
python3-jsondiff File 1018 B 0755
python3-jsonpatch File 3.58 KB 0755
python3-jsonpointer File 1.31 KB 0755
python3-jsonschema File 398 B 0755
python3-pasteurize File 388 B 0755
python3-pbr File 152 B 0755
python3.6 File 4.32 MB 0755
python3.6-config File 3.21 KB 0755
python3.6m File 4.32 MB 0755
python3.6m-config File 3.21 KB 0755
python3m File 4.32 MB 0755
python3m-config File 3.21 KB 0755
pyversions File 14.75 KB 0755
qt-faststart File 9.99 KB 0755
ranlib File 58.27 KB 0755
rcp File 98.14 KB 0755
rdjpgcom File 9.99 KB 0755
rdma File 26.07 KB 0755
readelf File 582.46 KB 0755
realpath File 46.21 KB 0755
recode-sr-latin File 14.07 KB 0755
rename.ul File 14.07 KB 0755
rendercheck File 55.65 KB 0755
renice File 14.07 KB 0755
replace File 3.42 MB 0755
reset File 22 KB 0755
resizecons File 18.13 KB 0755
resizepart File 38.08 KB 0755
resolveip File 3.44 MB 0755
rev File 10.07 KB 0755
rgrep File 30 B 0755
ristretto File 228.32 KB 0755
rlogin File 710.79 KB 0755
rotatelogs File 18.07 KB 0755
routef File 208 B 0755
routel File 1.62 KB 0755
rpcgen File 98.53 KB 0755
rsh File 710.79 KB 0755
rstart File 2.55 KB 0755
rstartd File 1.43 KB 0755
rsync File 496.43 KB 0755
rtstat File 22.35 KB 0755
run-mailcap File 17.74 KB 0755
run-one File 3.51 KB 0755
run-one-constantly File 3.51 KB 0755
run-one-until-failure File 3.51 KB 0755
run-one-until-success File 3.51 KB 0755
run-this-one File 3.51 KB 0755
run-with-aspell File 57 B 0755
runcon File 34.18 KB 0755
rview File 2.55 MB 0755
rvim File 2.55 MB 0755
savelog File 10.22 KB 0755
sbattach File 50.33 KB 0755
sbkeysync File 58.55 KB 0755
sbsiglist File 50.39 KB 0755
sbsign File 54.39 KB 0755
sbvarsign File 54.45 KB 0755
sbverify File 54.33 KB 0755
scp File 98.14 KB 0755
screen File 455.01 KB 0755
screendump File 9.99 KB 0755
script File 30.07 KB 0755
scriptreplay File 26.08 KB 0755
sdiff File 50.09 KB 0755
secret-tool File 18.07 KB 0755
see File 17.74 KB 0755
select-default-iwrap File 474 B 0755
select-editor File 2.38 KB 0755
sensible-browser File 1.18 KB 0755
sensible-editor File 1.08 KB 0755
sensible-pager File 433 B 0755
sensors File 26.2 KB 0755
sensors-conf-convert File 13.7 KB 0755
seq File 46.18 KB 0755
sessreg File 13.99 KB 0755
set_unicharset_properties File 114.2 KB 0755
setarch File 18.34 KB 0755
setfacl File 34.68 KB 0755
setkeycodes File 10.07 KB 0755
setleds File 14.05 KB 0755
setlogcons File 10.07 KB 0755
setmetamode File 10.1 KB 0755
setpci File 26.08 KB 0755
setsid File 10.07 KB 0755
setterm File 42.08 KB 0755
setxkbmap File 22.39 KB 0755
sftp File 150.35 KB 0755
sg File 39.4 KB 4755
sha1sum File 46.21 KB 0755
sha224sum File 54.21 KB 0755
sha256sum File 54.21 KB 0755
sha384sum File 58.21 KB 0755
sha512sum File 58.21 KB 0755
shapeclustering File 50.2 KB 0755
shasum File 9.15 KB 0755
showconsolefont File 18.07 KB 0755
showkey File 14.07 KB 0755
showrgb File 9.99 KB 0755
shred File 58.21 KB 0755
shuf File 54.18 KB 0755
size File 30.3 KB 0755
skill File 26.08 KB 0755
slabtop File 18.08 KB 0755
slogin File 710.79 KB 0755
smproxy File 22 KB 0755
snap File 23.88 MB 0755
snapctl File 8.42 MB 0755
snapfuse File 38.13 KB 0755
snice File 26.08 KB 0755
soelim File 30.2 KB 0755
sort File 110.47 KB 0755
sos File 596 B 0755
sos-collector File 1.04 KB 0755
sosreport File 1.03 KB 0755
sotruss File 4.21 KB 0755
splain File 18.7 KB 0755
split File 54.63 KB 0755
splitfont File 9.99 KB 0755
sprof File 26.21 KB 0755
ssh File 710.79 KB 0755
ssh-add File 338.13 KB 0755
ssh-agent File 354.14 KB 2755
ssh-argv0 File 1.42 KB 0755
ssh-copy-id File 10.41 KB 0755
ssh-import-id File 1.73 KB 0755
ssh-import-id-gh File 782 B 0755
ssh-import-id-lp File 782 B 0755
ssh-keygen File 410.16 KB 0755
ssh-keyscan File 410.16 KB 0755
start-pulseaudio-x11 File 1.51 KB 0755
startx File 5.39 KB 0755
startxfce4 File 2.9 KB 0755
stat File 78.21 KB 0755
stdbuf File 46.18 KB 0755
strace File 1.31 MB 0755
strace-log-merge File 2.58 KB 0755
strings File 30.5 KB 0755
strip File 230.2 KB 0755
sudo File 145.59 KB 4755
sudoedit File 145.59 KB 4755
sudoreplay File 54.81 KB 0755
sum File 38.19 KB 0755
symcryptrun File 110.73 KB 0755
systemd-analyze File 1.49 MB 0755
systemd-cat File 10.07 KB 0755
systemd-cgls File 14.07 KB 0755
systemd-cgtop File 30.09 KB 0755
systemd-delta File 22.07 KB 0755
systemd-detect-virt File 10.06 KB 0755
systemd-mount File 42.09 KB 0755
systemd-path File 10.06 KB 0755
systemd-resolve File 86.07 KB 0755
systemd-run File 42.07 KB 0755
systemd-socket-activate File 18.07 KB 0755
systemd-stdio-bridge File 14.07 KB 0755
systemd-umount File 42.09 KB 0755
tabs File 13.99 KB 0755
tac File 38.18 KB 0755
tail File 66.24 KB 0755
taskset File 30.08 KB 0755
tbl File 126.2 KB 0755
tee File 34.21 KB 0755
telnet File 108.42 KB 0755
telnet.netkit File 108.42 KB 0755
tesseract File 26.09 KB 0755
test File 46.18 KB 0755
text2image File 190.2 KB 0755
thunar File 755.85 KB 0755
thunar-settings File 333 B 0755
thunar-volman File 42.41 KB 0755
thunar-volman-settings File 38.07 KB 0755
tic File 82.11 KB 0755
time File 14.38 KB 0755
timedatectl File 22.07 KB 0755
timeout File 38.63 KB 0755
tkconch3 File 386 B 0755
tload File 14.09 KB 0755
tmux File 563.56 KB 0755
toe File 13.99 KB 0755
top File 105.77 KB 0755
touch File 86.21 KB 0755
tput File 18.02 KB 0755
tr File 46.18 KB 0755
tracepath File 14.01 KB 0755
traceroute6 File 18.02 KB 4755
traceroute6.iputils File 18.02 KB 4755
transset File 18.48 KB 0755
trial3 File 382 B 0755
troff File 719.34 KB 0755
truncate File 38.18 KB 0755
tset File 22 KB 0755
tsort File 34.18 KB 0755
tty File 30.18 KB 0755
twist3 File 382 B 0755
twistd3 File 384 B 0755
tz_convert File 38.02 KB 0755
tzselect File 15.04 KB 0755
ua File 442 B 0755
ubuntu-advantage File 442 B 0755
ubuntu-bug File 2.5 KB 0755
ubuntu-core-launcher File 127.21 KB 4755
ubuntu-distro-info File 18.59 KB 0755
ubuntu-support-status File 7.84 KB 0755
ucf File 39.73 KB 0755
ucfq File 18.91 KB 0755
ucfr File 10.47 KB 0755
uconv File 50.6 KB 0755
ucs2any File 21.99 KB 0755
udisksctl File 54.07 KB 0755
ul File 14.01 KB 0755
unattended-upgrade File 82.55 KB 0755
unattended-upgrades File 82.55 KB 0755
unexpand File 38.21 KB 0755
unicharset_extractor File 102.16 KB 0755
unicode_stop File 530 B 0755
uniq File 42.21 KB 0755
unlink File 30.18 KB 0755
unlzma File 74.36 KB 0755
unmkinitramfs File 2.94 KB 0755
unpigz File 114.2 KB 0755
unshare File 18.27 KB 0755
unsquashfs File 99.71 KB 0755
unxz File 74.36 KB 0755
unzip File 174.13 KB 0755
unzipsfx File 78.12 KB 0755
update-alternatives File 46.01 KB 0755
update-desktop-database File 22.07 KB 0755
update-gconf-defaults File 5.87 KB 0755
update-mime-database File 50.19 KB 0755
updatedb File 46.08 KB 0755
updatedb.mlocate File 46.08 KB 0755
upower File 13.99 KB 0755
uptime File 10.07 KB 0755
usb-devices File 4.12 KB 0755
usbhid-dump File 22.08 KB 0755
users File 34.18 KB 0755
utmpdump File 22.07 KB 0755
uuidgen File 14.07 KB 0755
uuidparse File 34.08 KB 0755
vcs-run File 6.75 KB 0755
verve-focus File 9.99 KB 0755
vi File 2.55 MB 0755
view File 2.55 MB 0755
viewres File 26.96 KB 0755
vigpg File 2.58 KB 0755
vim File 2.55 MB 0755
vim.basic File 2.55 MB 0755
vim.tiny File 1.06 MB 0755
vimdiff File 2.55 MB 0755
vimtutor File 2.05 KB 0755
vmhgfs-fuse File 50.48 KB 0755
vmstat File 34.09 KB 0755
vmtoolsd File 54.25 KB 0755
vmware-checkvm File 10.07 KB 0755
vmware-hgfsclient File 10.07 KB 0755
vmware-namespace-cmd File 17.99 KB 0755
vmware-rpctool File 17.99 KB 0755
vmware-toolbox-cmd File 38.28 KB 0755
vmware-vgauth-cmd File 13.99 KB 0755
vmware-vgauth-smoketest File 18.01 KB 0755
vmware-vmblock-fuse File 18.41 KB 0755
vmware-xferlogs File 10.07 KB 0755
vmwarectrl File 10.1 KB 0755
volname File 9.99 KB 0755
w File 18.07 KB 0755
w.procps File 18.07 KB 0755
wall File 30.08 KB 2755
watch File 22.41 KB 0755
watchgnupg File 13.99 KB 0755
wc File 42.19 KB 0755
wget File 487.56 KB 0755
whatis File 46.98 KB 0755
whereis File 26.51 KB 0755
which File 946 B 0755
who File 50.21 KB 0755
whoami File 30.18 KB 0755
wifi-status File 2.06 KB 0755
word-list-compress File 9.99 KB 0755
wordlist2dawg File 18.16 KB 0755
wpa_passphrase File 62 KB 0755
write File 13.99 KB 2755
wrjpgcom File 9.99 KB 0755
x-session-manager File 2.9 KB 0755
x-terminal-emulator File 2.36 KB 0755
x-window-manager File 382.26 KB 0755
x11perf File 189.16 KB 0755
x11perfcomp File 2.74 KB 0755
x86_64 File 18.34 KB 0755
x86_64-linux-gnu-addr2line File 30.55 KB 0755
x86_64-linux-gnu-ar File 58.24 KB 0755
x86_64-linux-gnu-as File 895.98 KB 0755
x86_64-linux-gnu-c++filt File 26.12 KB 0755
x86_64-linux-gnu-cpp File 1022.94 KB 0755
x86_64-linux-gnu-cpp-7 File 1022.94 KB 0755
x86_64-linux-gnu-cpp-8 File 1.01 MB 0755
x86_64-linux-gnu-dwp File 2.75 MB 0755
x86_64-linux-gnu-elfedit File 30.45 KB 0755
x86_64-linux-gnu-g++ File 1022.94 KB 0755
x86_64-linux-gnu-g++-7 File 1022.94 KB 0755
x86_64-linux-gnu-gcc File 1022.94 KB 0755
x86_64-linux-gnu-gcc-7 File 1022.94 KB 0755
x86_64-linux-gnu-gcc-8 File 1.01 MB 0755
x86_64-linux-gnu-gcc-ar File 30.47 KB 0755
x86_64-linux-gnu-gcc-ar-7 File 30.47 KB 0755
x86_64-linux-gnu-gcc-ar-8 File 26.47 KB 0755
x86_64-linux-gnu-gcc-nm File 30.47 KB 0755
x86_64-linux-gnu-gcc-nm-7 File 30.47 KB 0755
x86_64-linux-gnu-gcc-nm-8 File 26.47 KB 0755
x86_64-linux-gnu-gcc-ranlib File 30.47 KB 0755
x86_64-linux-gnu-gcc-ranlib-7 File 30.47 KB 0755
x86_64-linux-gnu-gcc-ranlib-8 File 26.47 KB 0755
x86_64-linux-gnu-gccgo-8 File 1.01 MB 0755
x86_64-linux-gnu-gcov File 616.09 KB 0755
x86_64-linux-gnu-gcov-7 File 616.09 KB 0755
x86_64-linux-gnu-gcov-8 File 640.09 KB 0755
x86_64-linux-gnu-gcov-dump File 499.93 KB 0755
x86_64-linux-gnu-gcov-dump-7 File 499.93 KB 0755
x86_64-linux-gnu-gcov-dump-8 File 491.95 KB 0755
x86_64-linux-gnu-gcov-tool File 535.99 KB 0755
x86_64-linux-gnu-gcov-tool-7 File 535.99 KB 0755
x86_64-linux-gnu-gcov-tool-8 File 512.02 KB 0755
x86_64-linux-gnu-go-8 File 1.76 MB 0755
x86_64-linux-gnu-gofmt-8 File 127.6 KB 0755
x86_64-linux-gnu-gold File 2.97 MB 0755
x86_64-linux-gnu-gprof File 99.73 KB 0755
x86_64-linux-gnu-ld File 1.7 MB 0755
x86_64-linux-gnu-ld.bfd File 1.7 MB 0755
x86_64-linux-gnu-ld.gold File 2.97 MB 0755
x86_64-linux-gnu-nm File 43.27 KB 0755
x86_64-linux-gnu-objcopy File 230.2 KB 0755
x86_64-linux-gnu-objdump File 404.55 KB 0755
x86_64-linux-gnu-pkg-config File 2.06 KB 0755
x86_64-linux-gnu-python3-config File 3.21 KB 0755
x86_64-linux-gnu-python3.6-config File 3.21 KB 0755
x86_64-linux-gnu-python3.6m-config File 3.21 KB 0755
x86_64-linux-gnu-python3m-config File 3.21 KB 0755
x86_64-linux-gnu-ranlib File 58.27 KB 0755
x86_64-linux-gnu-readelf File 582.46 KB 0755
x86_64-linux-gnu-size File 30.3 KB 0755
x86_64-linux-gnu-strings File 30.5 KB 0755
x86_64-linux-gnu-strip File 230.2 KB 0755
x86_64-pc-linux-gnu-pkg-config File 50.09 KB 0755
xarchiver File 282.96 KB 0755
xargs File 70.21 KB 0755
xauth File 50.81 KB 0755
xbiff File 19.88 KB 0755
xcalc File 35.05 KB 0755
xclip File 22.02 KB 0755
xclip-copyfile File 572 B 0755
xclip-cutfile File 386 B 0755
xclip-pastefile File 133 B 0755
xclipboard File 18.27 KB 0755
xclock File 48.76 KB 0755
xcmsdb File 34.74 KB 0755
xconsole File 18.9 KB 0755
xcursorgen File 13.99 KB 0755
xcutsel File 14.26 KB 0755
xdelta3 File 150.3 KB 0755
xdg-desktop-icon File 20.09 KB 0755
xdg-desktop-menu File 42.2 KB 0755
xdg-email File 27.27 KB 0755
xdg-icon-resource File 29.26 KB 0755
xdg-mime File 41 KB 0755
xdg-open File 24.65 KB 0755
xdg-screensaver File 36.79 KB 0755
xdg-settings File 36.85 KB 0755
xdg-user-dir File 234 B 0755
xdg-user-dirs-update File 18.07 KB 0755
xditview File 99.84 KB 0755
xdpyinfo File 34.76 KB 0755
xdriinfo File 9.99 KB 0755
xedit File 661.05 KB 0755
xev File 30.48 KB 0755
xeyes File 23.41 KB 0755
xfburn File 247.04 KB 0755
xfce4-about File 122.37 KB 0755
xfce4-accessibility-settings File 46.15 KB 0755
xfce4-appearance-settings File 67 KB 0755
xfce4-appfinder File 122.59 KB 0755
xfce4-clipman File 62.05 KB 0755
xfce4-clipman-settings File 86.05 KB 0755
xfce4-dict File 130.64 KB 0755
xfce4-display-settings File 298.27 KB 0755
xfce4-find-cursor File 14.01 KB 0755
xfce4-keyboard-settings File 90.15 KB 0755
xfce4-mime-settings File 50.1 KB 0755
xfce4-mouse-settings File 82.27 KB 0755
xfce4-notes File 134.07 KB 0755
xfce4-notes-settings File 22 KB 0755
xfce4-notifyd-config File 85.99 KB 0755
xfce4-panel File 302.66 KB 0755
xfce4-popup-applicationsmenu File 1.53 KB 0755
xfce4-popup-clipman File 9.99 KB 0755
xfce4-popup-clipman-actions File 9.99 KB 0755
xfce4-popup-directorymenu File 1.46 KB 0755
xfce4-popup-notes File 10 KB 0755
xfce4-popup-places File 1.5 KB 0755
xfce4-popup-whiskermenu File 1.5 KB 0755
xfce4-popup-windowmenu File 1.46 KB 0755
xfce4-power-manager File 218.12 KB 0755
xfce4-power-manager-settings File 146.12 KB 0755
xfce4-screenshooter File 98.57 KB 0755
xfce4-sensors File 22 KB 0755
xfce4-session File 170.23 KB 0755
xfce4-session-logout File 10.38 KB 0755
xfce4-session-settings File 106.23 KB 0755
xfce4-settings-editor File 70.23 KB 0755
xfce4-settings-manager File 50.15 KB 0755
xfce4-taskmanager File 130.26 KB 0755
xfce4-terminal File 222.53 KB 0755
xfce4-terminal.wrapper File 1.1 KB 0755
xfconf-query File 26.66 KB 0755
xfd File 35.76 KB 0755
xfdesktop File 370.1 KB 0755
xfdesktop-settings File 138.59 KB 0755
xfhelp4 File 1.89 KB 0755
xflock4 File 1.51 KB 0755
xfontsel File 43.6 KB 0755
xfrun4 File 122.59 KB 0755
xfsettingsd File 102.27 KB 0755
xfwm4 File 382.26 KB 0755
xfwm4-settings File 98.23 KB 0755
xfwm4-tweaks-settings File 66.23 KB 0755
xfwm4-workspace-settings File 130.15 KB 0755
xgamma File 9.99 KB 0755
xgc File 74.12 KB 0755
xgettext File 260.64 KB 0755
xhost File 13.99 KB 0755
xinit File 18.17 KB 0755
xinput File 50.67 KB 0755
xkbbell File 14.01 KB 0755
xkbcomp File 207.72 KB 0755
xkbevd File 34.08 KB 0755
xkbprint File 86.03 KB 0755
xkbvleds File 22.77 KB 0755
xkbwatch File 18.87 KB 0755
xkeystone File 16.58 KB 0755
xkill File 13.99 KB 0755
xload File 14.62 KB 0755
xlogo File 18.88 KB 0755
xlsatoms File 9.99 KB 0755
xlsclients File 14 KB 0755
xlsfonts File 18.09 KB 0755
xmag File 40.04 KB 0755
xman File 68.9 KB 0755
xmessage File 22.88 KB 0755
xml2-config File 1.6 KB 0755
xmodmap File 34.34 KB 0755
xmore File 10.2 KB 0755
xprop File 40.29 KB 0755
xrandr File 62.09 KB 0755
xrdb File 26.09 KB 0755
xrefresh File 10.07 KB 0755
xscreensaver File 264.15 KB 0755
xscreensaver-command File 21.99 KB 0755
xscreensaver-demo File 207.55 KB 0755
xscreensaver-getimage File 139.77 KB 0755
xscreensaver-getimage-file File 30.91 KB 0755
xscreensaver-getimage-video File 4.41 KB 0755
xscreensaver-text File 25.28 KB 0755
xset File 29.99 KB 0755
xsetmode File 9.99 KB 0755
xsetpointer File 9.99 KB 0755
xsetroot File 18 KB 0755
xsetwacom File 55.54 KB 0755
xslt-config File 2.47 KB 0755
xsm File 94.45 KB 0755
xstdcmap File 14.57 KB 0755
xsubpp File 5.04 KB 0755
xvidtune File 39.41 KB 0755
xvinfo File 13.99 KB 0755
xwd File 30.01 KB 0755
xwininfo File 46.08 KB 0755
xwud File 25.99 KB 0755
xxd File 18.12 KB 0755
xz File 74.36 KB 0755
xzcat File 74.36 KB 0755
xzcmp File 6.48 KB 0755
xzdiff File 6.48 KB 0755
xzegrep File 5.76 KB 0755
xzfgrep File 5.76 KB 0755
xzgrep File 5.76 KB 0755
xzless File 1.76 KB 0755
xzmore File 2.11 KB 0755
yarn File 20.25 KB 0755
yelp File 54.07 KB 0755
yes File 30.18 KB 0755
zdump File 18.05 KB 0755
zipdetails File 47.36 KB 0755
zipgrep File 2.88 KB 0755
zipinfo File 174.13 KB 0755